package io.gitlab.jfronny.libjf.config.impl;

import com.google.common.collect.ImmutableMap;
import io.gitlab.jfronny.libjf.config.api.ConfigHolder;

import java.util.HashMap;
import java.util.Map;

public class ConfigHolderImpl implements ConfigHolder {
    @Deprecated public static final ConfigHolderImpl INSTANCE = new ConfigHolderImpl();
    private ConfigHolderImpl() {}
    private final Map<String, Config> configs = new HashMap<>();

    @Override
    public void register(String modId, Class<?> config) {
        if (!isRegistered(config))
            configs.put(modId, new Config(modId, config));
    }

    @Override
    public Map<String, Config> getRegistered() {
        return ImmutableMap.copyOf(configs);
    }

    public boolean isRegistered(Class<?> config) {
        for (Config value : configs.values()) {
            if (value.configClass.equals(config))
                return true;
        }
        return false;
    }
}
