package io.gitlab.jfronny.libjf.devutil;

import com.mojang.authlib.minecraft.TelemetryEvent;
import com.mojang.authlib.minecraft.TelemetryPropertyContainer;
import com.mojang.authlib.minecraft.TelemetrySession;
import com.mojang.authlib.minecraft.UserApiService;

import java.util.UUID;
import java.util.concurrent.Executor;
import java.util.function.Consumer;

public class NoOpUserApi implements UserApiService {
    @Override
    public boolean serversAllowed() {
        return true;
    }

    @Override
    public boolean realmsAllowed() {
        return false;
    }

    @Override
    public boolean chatAllowed() {
        return true;
    }

    @Override
    public boolean telemetryAllowed() {
        return false;
    }

    @Override
    public boolean isBlockedPlayer(UUID playerID) {
        return false;
    }

    @Override
    public void refreshBlockList() {
    }

    @Override
    public TelemetrySession newTelemetrySession(Executor executor) {
        return new TelemetrySession() {
            @Override
            public boolean isEnabled() {
                return false;
            }

            @Override
            public TelemetryPropertyContainer globalProperties() {
                return new TelemetryPropertyContainer() {
                    @Override
                    public void addProperty(String id, String value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, int value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, boolean value) {
                        // ignored
                    }

                    @Override
                    public void addNullProperty(String id) {
                        // ignored
                    }
                };
            }

            @Override
            public void eventSetupFunction(Consumer<TelemetryPropertyContainer> eventSetupFunction) {
                // ignored
            }

            @Override
            public TelemetryEvent createNewEvent(String type) {
                return new TelemetryEvent() {
                    @Override
                    public void send() {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, String value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, int value) {
                        // ignored
                    }

                    @Override
                    public void addProperty(String id, boolean value) {
                        // ignored
                    }

                    @Override
                    public void addNullProperty(String id) {
                        // ignored
                    }
                };
            }
        };
    }
}
